/*
PPKMouseAddon
 by Mnjul/purincess (Min-Zhong Lu)
 # Middle Sea, Mnjul's Intimate Home

Copyright 2007-2010 Min-Zhong Lu

This file is part of PPKMouseAddon.

PPKMouseAddon is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your
option) any later version.

PPKMouseAddon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with PPKMouseAddon.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "stdafx.h"
#include "ApplicationUtility.h"

#include <sstream>

void ApplicationUtility::seTranslatorInternal(unsigned int errCode, EXCEPTION_POINTERS* exPtr) const{
	throw errCode;
}

void ApplicationUtility::showTypeSafeErrorMessage(const unsigned int errCode, const wchar_t* from) const{
	std::wostringstream codeStringStream;

	codeStringStream << std::hex << std::uppercase << errCode;

	std::wstring errString(L"");

	switch(errCode){
		case EXCEPTION_ACCESS_VIOLATION:
			errString += L"sHW/I줣ӸIO";
			break;
		default:
			errString += L"ƫ_X(~)";
			break;
	}

	std::wstring msg(L"b\"");
	msg += from;
	msg += L"\"aoͿ~C~NXO 0x";
	msg += codeStringStream.str();
	msg += L" (";
	msg += errString;
	msg += L")\n\nЧoӰD(]AAFƱA~X{oӰD)^pttPCManOWC";

	MessageBox(GetActiveWindow(), msg.c_str(), L"PPKƹ~", MB_ICONERROR);
}

void ApplicationUtility::showLastErrorMessage(const wchar_t* message, UINT type) const{
	wchar_t errMessage[1024] = {0};
	FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL, GetLastError(), MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), errMessage, 1023, NULL);

	std::wstring totalMessage(message);

	totalMessage += L"\n\n";
	totalMessage += errMessage;

	MessageBox(GetActiveWindow(), totalMessage.c_str(), L"PPKƹ~", type);
}
