/*
PPKMouseAddon
 by Mnjul/purincess (Min-Zhong Lu)
 # Middle Sea, Mnjul's Intimate Home

Copyright 2007-2010 Min-Zhong Lu

This file is part of PPKMouseAddon.

PPKMouseAddon is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your
option) any later version.

PPKMouseAddon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with PPKMouseAddon.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __OPTIONSDLG_H
#define __OPTIONSDLG_H

using Win32xx::CDialog;

class OptionsDlg : public CDialog
{
public:
	OptionsDlg(UINT idDialog, HWND hwndParent) : CDialog(idDialog, hwndParent){
	}
	virtual ~OptionsDlg(){
	}

protected:
	virtual BOOL OnInitDialog();
	virtual BOOL OnCommand(WPARAM wparam, LPARAM lparam);
	virtual void OnOK();

protected:
	void onOptLRMapClicked();
	inline LRESULT setComboBoxCurSel(int idComboBox, int sel);
	inline int getComboBoxCurSel(int idComboBox) const;
	inline void setHotkeyHotKey(int idHotkey, WORD vKeyCode, WORD modifiers);
	inline void getHotkeyHotKey(int idHotkey, WORD* vKeyCode, WORD* modifiers) const;

public:
	inline UINT isButtonChecked(int idButton) const;

private:
	inline void setLRMapText();
	inline void setCmbButtonWheelScrollText(const int idCMB);

private:
	OptionsDlg(const OptionsDlg&);	//no copy constructor
	OptionsDlg& operator=(const OptionsDlg*);	// no assignment operation constructor

};

#endif